pSpeed = GetFloatParam("speed", 0.6)
power = GetFloatParam("power", 5000)

function rnd(mi, ma)
	return math.random()*(ma-mi) + mi
end

function init()
	motor = FindJoints("motor")
	button = FindShapes("button")
	body = FindBody("doorbody")
	smokePos = FindLocations("smoke")
	bt = GetBodyTransform(body)
	limitMin, limitMax = GetJointLimits(motor[1])
	for i=1, #button do
	SetTag(button[i], "interact", "Flip switch")
	end
	motorSound = LoadLoop("MOD/sound/doorLoop.ogg")
	stopSound = LoadSound("MOD/sound/doorClose.ogg")
	startSound = LoadSound("MOD/sound/doorOpen.ogg")
	timer = 0.0
	buttonUp = false
	isMoving = false
	lastMotorPos = GetJointMovement(motor[1])
	stuckTimer = 0
end


function tick(dt)
	timer = timer + dt
	bt = GetBodyTransform(body)

	for i=1, #button do
		if IsShapeBroken(button[i]) then
			RemoveTag(button[i], "interact")
		end

		if GetPlayerInteractShape() == button[i] and InputPressed("interact") then
			local t = GetShapeLocalTransform(button[i])
			PlaySound(startSound, bt.pos)
			if buttonUp then
				lastMotorPos = GetJointMovement(motor[1]) + 0.1
				buttonUp = false
				stuckTimer = 0
			else
				lastMotorPos = GetJointMovement(motor[1]) - 0.1
				buttonUp = true
				stuckTimer = 0
			end
		end
	end

	eps = 0.01
	if stuckTimer < 1 then	
		if buttonUp then
			if GetJointMovement(motor[1]) <= lastMotorPos and isMoving then
				stuckTimer = stuckTimer + dt
			else
				stuckTimer = 0
				lastMotorPos = GetJointMovement(motor)
				if GetJointMovement(motor[1]) < limitMax-eps and stuckTimer < 1 then
					for i=1, #motor do
					SetJointMotor(motor[i], -pSpeed, power)
					end
					PlayLoop(motorSound, bt.pos)
					isMoving = true
				else
					if isMoving then
						PlaySound(stopSound, bt.pos)
					end
					isMoving = false
				end
			end
		else
			if GetJointMovement(motor[1]) >= lastMotorPos and isMoving then
				stuckTimer = stuckTimer + dt
			else
				stuckTimer = 0
				lastMotorPos = GetJointMovement(motor[1])
				if GetJointMovement(motor[1]) > limitMin+eps and stuckTimer < 1 then
				for i=1, #motor do
				SetJointMotor(motor[i], pSpeed, power)
				end
				PlayLoop(motorSound, bt.pos)
				isMoving = true
				else
					if isMoving then
						PlaySound(stopSound, bt.pos)
					end
					isMoving = false
				end
			end
		end
	end
end


function update(dt)
	if isMoving then
		for k=1, #smokePos do
			ParticleReset()
			ParticleType("smoke")
			ParticleColor(0.8, 0.8, 0.8)
			ParticleRadius(0.1, 0.2)
			ParticleGravity(0.8)
			ParticleRotation(5, 1)
			local tagX = tonumber(string.sub(GetTagValue(smokePos[k], "X"), 1, 2))
			local tagY = tonumber(string.sub(GetTagValue(smokePos[k], "Y"), 1,2))
			local tagZ = tonumber(string.sub(GetTagValue(smokePos[k], "Z"), 1,2))
			local tagX2 = tonumber(string.sub(GetTagValue(smokePos[k], "X"), 3, 4))
			local tagY2 = tonumber(string.sub(GetTagValue(smokePos[k], "Y"), 3,4))
			local tagZ2 = tonumber(string.sub(GetTagValue(smokePos[k], "Z"), 3,4))
			SpawnParticle(VecAdd(GetLocationTransform(smokePos[k]).pos,Vec(rnd(-0.2, 0.2),rnd(-0.2, 0.2),rnd(-0.2, 0.2))), Vec(rnd(tagX, tagX2),rnd(tagY, tagY2),rnd(tagZ, tagZ2)) , rnd(0.5, 2.5))
		end
	else
		for k=1, #smokePos do
			ParticleReset()
			ParticleType("smoke")
			ParticleColor(0.8, 0.8, 0.8)
			ParticleRadius(0.05, 0.1)
			ParticleGravity(0.1)
			ParticleRotation(3, 1)
			local tagX = tonumber(string.sub(GetTagValue(smokePos[k], "X"), 1, 2))
			local tagY = tonumber(string.sub(GetTagValue(smokePos[k], "Y"), 1,2))
			local tagZ = tonumber(string.sub(GetTagValue(smokePos[k], "Z"), 1,2))
			local tagX2 = tonumber(string.sub(GetTagValue(smokePos[k], "X"), 3, 4))
			local tagY2 = tonumber(string.sub(GetTagValue(smokePos[k], "Y"), 3,4))
			local tagZ2 = tonumber(string.sub(GetTagValue(smokePos[k], "Z"), 3,4))
			SpawnParticle(VecAdd(GetLocationTransform(smokePos[k]).pos,Vec(rnd(-0.2, 0.2),rnd(-0.2, 0.2),rnd(-0.2, 0.2))), Vec(rnd(0, 0),rnd(0, -1),rnd(0, 0)) , rnd(0.5, 2))
		end	
	end
end